...program to compare two files
...call with  COMPARE FILE1 FILE2
...hit CR or '?' to stop/start printing, ESC to abort

BUFSIZ:	EQU 02000  ...06000 ...need space for 2 buffers

/SEG
START:	PROC
	LDL SAVSP,RR14; LDL RR14,#MYSP
	GETFNMS()  ...get filenames from cmd line ->NAME1 & NAME2
	R3:=flag; RES R3,15; R3->flag
/NONSEG
	COMPARE()
	R3:=flag; SET R3,15; R3->flag
/SEG
	LDL RR14,SAVSP
	RET

GETFNMS: ...get 2 names from cmd line ->NAME1 & NAME2
	...RR12 pts. to cmd line
	GETNAM(LDAR RR2,NAME1_)
	GETNAM(LDAR RR2,NAME2_)
	RET

GETNAM:	...enter with RR12 pointing to cmd line, RR2 place to put name
	...get name (put 0 at end) & update RR12
	while RL0:=@RR12=' ' or RL0=9 or RL0=',' do R13:+1
	while RL0:=@RR12<>0D and RL0<>' ' and RL0<>9 and RL0<>',' do begin
	  RL0:->@RR2'; R13:+1
	end
	RL0:=0->@RR2
	RET

/NONSEG
DIFFLG:	WORD 0
INCHAR:	BYTE 0
ABORTFLG: BYTE 0

COMPARE: PROC  ...enter with filenames in NAME1 & NAME2
	save R6..R11
	if B.NAME1=0 or B.NAME2=0 then begin
	  ?"MUST GIVE 2 FILENAMES"
	  JR CMPX
	end
	R8:=OPEN(^NAME1)
	R9:=OPEN(^NAME2)
	if R8=-1 or R9=-1 then JR CMPX
	DIFFLG:=0  ...CMPBUFS sets=1 if difference
	ABORTFLG:=0
	SUBL RR6,RR6  ...RR6=current file pos.
LUP~	  R10:=READ(R8,^BUFF1); R11:=READ(R9,^BUFF2)
	  if R10=0 or R11=0 then JR LUPX
	  if R10=-1 or R11=-1 then JR CMPCLS
	  LDL RR4,RR6  ...for CMPBUFS
	  if R3:=R10<>R11 then begin
	    if R3>R11 then R3:=R11
	    CMPBUFS(R3)
	    ABORTFLG==0; JR NZ,CMPCLS
	    JR DIFSIZ
	  end
	  CMPBUFS(R3)
	  ABORTFLG==0; JR NZ,CMPCLS
	  R10:=0; ADDL RR6,RR10
	  JR LUP
LUPX~
	if R10<>0 or R11<>0 then begin
DIFSIZ~	  ?"Files are of different size"
	end else if DIFFLG=0 then ?"Files are identical"
CMPCLS~	close(R8); close(R9)
CMPX~	restore R6..R11
	RET

OPEN:	...open file with name @R3; ret. R3=LU; print msg if error
	save R6,R7
	R6:=R3
	if R3:=open(R3,0,->RL5)=-1 then begin
	  RL7:=RL5
	  PRTSTR(R6)
	  if RL7=0C7 then ?" NOT FOUND"
	  else ?": OPEN ERROR ",RL5
	  R3:=-1; RL5:=RL7
	end
	restore R6,R7
	RET

READ:	...read LU R3 to buffer R5; print msg. if err; ret. R3=len read
	save R6,R7
	R6:=R3
	if R3:=read(R3,R5,BUFSIZ,->RL5)=-1 then begin
	  RL7:=RL5
	  PRTSTR(R6)
	  ?": READ ERROR ",RL7
	  R3:=-1; RL5:=RL7
	end
	restore R6,R7
	RET

PRTSTR:	...print string @R3 until 0
	save R8
	R8:=R3
	while RL3:=@R8<>0 do begin putchar(RL3); R8:+1 end
	restore R8
	RET

CMPBUFS: ...compare data in BUFF1 and BUFF2; if different, print differences
	...R3=len to do; RR4=starting file offset
	save R6..R11
	R8:=R3; LDL RR10,RR4
	R6:=^BUFF1; R7:=^BUFF2
	while R8<>0 and ABORTFLG=0 do begin
	  CPSIRB @R6,@R7,R8,NE
	  if zero then begin
	    if DIFFLG=0 then ?"File offset    File 1:   File 2:"
	    DIFFLG:=1
	    R3:=R6-1-^BUFF1; R2:=0; ADDL RR2,RR10
	    if R2<>0 then printf("%w",R2:) else printf("    ")
	    printf("%w  ",R3)
	    PRTBYT(B.@R6[-1])
	    PRTBYT(B.@R7[-1])
	    printf("\n")
	    TSTKEY()
	  end
	end
	restore R6..R11
	RET

TSTKEY:	...if key CR,'?', stop until another
	...if ESC pressed, set ABORTFLG and print abort msg.
	RL3:=GET1IF(); RET Z
	if RL3=0D or RL3='?' then begin
	  repeat getchar() until RL3=0D or RL3='?' or RL3=01B;
	end
	if RL3=01B then begin
	  ABORTFLG:=1
	  ?"PROGRAM ABORTED"
	end
	RET

GET1IF:	...get char. from keybd ->RL3 if ready; ret. Z=0 iff char.
	B.read(0,^INCHAR,0)==0; RET Z
	RL3:=INCHAR; RET

PRTBYT:	...enter with RL3=byte to print in hex & ascii
	...also print spaces first
	printf("      %b",RL3)
	if RL3>=020 and RL3<07F then printf(" %c",RL3) else printf("  ")
	RET

END:

SAVSP:	LONG 0

NAME1_:
NAME1:	DEFS 40
NAME2_:
NAME2:	DEFS 40

	DEFS 0100
MYSP:

BUFF1:	DEFS BUFSIZ
BUFF2:	DEFS BUFSIZ

/MAP UNDEF
/WRITE "/IMAGE COMPARE ",START," ",END," E=",START

/SEG

at end) & update RR